package ru.yurannnzzz.compat.figuraheadseverywhere.mixin;

import com.mojang.authlib.GameProfile;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.PlayerFaceRenderer;
import net.minecraft.resources.ResourceLocation;
import org.figuramc.figura.avatar.Avatar;
import org.figuramc.figura.avatar.AvatarManager;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import ru.yurannnzzz.compat.figuraheadseverywhere.util.SkinCache;

@Mixin(value = PlayerFaceRenderer.class, remap = false)
public class PlayerFaceRendererMixin {
    @Inject(
            at = @At("HEAD"),
            method = "draw(Lnet/minecraft/client/gui/GuiGraphics;Lnet/minecraft/resources/ResourceLocation;IIIZZ)V",
            cancellable = true
    )
    private static void drawInPlace(GuiGraphics guiGraphics, ResourceLocation atlasLocation, int x, int y, int size, boolean p_drawHat, boolean upsideDown, CallbackInfo ci) {
        if (!SkinCache.PROFILE_BY_SKIN.containsKey(atlasLocation)) return;

        GameProfile profile = SkinCache.PROFILE_BY_SKIN.get(atlasLocation);
        if (profile == null) return;

        Avatar avatar = AvatarManager.getAvatarForPlayer(profile.getId());
        if (avatar != null && avatar.renderPortrait(guiGraphics, x, y, size, (float)(size * 2), upsideDown)) {
            ci.cancel();
        }
    }
}
