package ru.yurannnzzz.compat.figuraheadseverywhere.mixin;

import com.mojang.authlib.GameProfile;
import net.minecraft.client.multiplayer.PlayerInfo;
import net.minecraft.client.resources.PlayerSkin;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import ru.yurannnzzz.compat.figuraheadseverywhere.util.SkinCache;

@Mixin(value = PlayerInfo.class, remap = false)
public class PlayerInfoMixin {
    @Shadow
    @Final
    private GameProfile profile;

    @Inject(
            at = @At("RETURN"),
            method = "getSkin()Lnet/minecraft/client/resources/PlayerSkin;"
    )
    private void cachePlayerSkin(CallbackInfoReturnable<PlayerSkin> cir) {
        SkinCache.cacheSkin(profile, cir.getReturnValue());
    }
}
